﻿// bspline.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <iostream>
using namespace std;

#include <windows.h> // win headers;
#include "glut.h" // this one includes the upper two headers;

#include <math.h>

int click_x = 0;
int click_y = 0;

//
// initial "screen" parameters;
//
#define ScreenWidth 640
#define ScreenHeight 480

//
// initial win parameters;
//
int win_width = ScreenWidth;
int win_height = ScreenHeight;

class Point {
public:
	int x;
	int y;
	Point(int cx = 0, int cy = 0) : x(cx), y(cy) {}
	friend ostream& operator<<(ostream &out, const Point& p);
}; 

ostream& operator<<(ostream &out, const Point& p) {
	out << "(" << p.x << ", " << p.y << ")";
	return out;
}

Point oo;

class Line {
public:
	Point p1;
	Point p2;
	Line(Point cp1 = oo, Point cp2 = oo) : p1(cp1), p2(cp2) {}
	friend ostream& operator<<(ostream &out, const Line& l);
}; 

ostream& operator<<(ostream &out, const Line& l) {
	out << l.p1 << " - " << l.p2;
	return out;
}

#define MAX_PP_COUNT 32

Point pp[MAX_PP_COUNT];
int pp_count = 0;

Line pl[MAX_PP_COUNT];
int pl_count = 0;

int p_ymin = 2048;
int p_ymax = 0;

bool calcX(int x1, int y1, int x2, int y2, int y, int &x) {

	x = (x2-x1)*(y-y1)/(y2-y1) + x1;

	bool f1;
	bool f2;

	if (x1 < x2) f1 = (x1 <= x) && (x <= x2);
	else f1 = (x2 <= x) && (x <= x1);

	if (y1 < y2) f2 = (y1 <= y) && (y <= y2);
	else f2 = (y2 <= y) && (y <= y1);

	return f1&&f2;

}

void drawPolygon() {

	if (pp_count > 2) {

			int i = 0;
			pl_count = 0;

			for(i = 1; i < pp_count; i++) {
					
				if (pp[i-1].y < p_ymin) p_ymin = pp[i-1].y;
				if (pp[i-1].y > p_ymax) p_ymax = pp[i-1].y;

				Line l(pp[i-1], pp[i]);
				pl[pl_count++] = l;

			}

			i = pp_count - 1;
			if (pp[i].y < p_ymin) p_ymin = pp[i].y;
			if (pp[i].y > p_ymax) p_ymax = pp[i].y;

			Line l(pp[i], pp[0]);
			pl[pl_count++] = l;

			glColor3d(255, 255, 0);

			Point r_pt[MAX_PP_COUNT];
			for(i = p_ymin; i <= p_ymax; i++) {

				int r_x;
				int r_pt_count = 0;

				for(int j = 0; j < pl_count; j++) {
					if (calcX(pl[j].p1.x, pl[j].p1.y, pl[j].p2.x, pl[j].p2.y, i, r_x)) {
						Point p(r_x, i);
						r_pt[r_pt_count++] = p;
					}
				}

				for(int j = 1; j < r_pt_count; j+=2) {

					glBegin(GL_LINES);
						glVertex2i(r_pt[j - 1].x, r_pt[j - 1].y);
						glVertex2i(r_pt[j].x, r_pt[j].y);
					glEnd();

				}
			}


			glColor3d(255, 0, 0);
			for(i = 0; i < pl_count; i++) {
				glBegin(GL_LINES);
					glVertex2i(pl[i].p1.x, pl[i].p1.y);
					glVertex2i(pl[i].p2.x, pl[i].p2.y);
				glEnd();
			}

			
	}

}

void initView() { // what we gonna show;

	glClearColor(0, 0, 0, 0);

}

void mouse(int button, int state, int mx, int my) {

	if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {

		click_x = mx;
		click_y = win_height - my;

		Point p(click_x, click_y);
		if (pp_count < MAX_PP_COUNT) pp[pp_count++] = p;
		
	} else if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN) {

		pp_count = 0;
		pl_count = 0;
		p_ymin = 2048;
		p_ymax = 0;

	}

	glutPostRedisplay();
	
}

void keyboard(unsigned char key, int x, int y)
{
	switch (key)  {
		case 27: // ESCAPE key
			cout << "escape pressed... exitting!" << endl;
			exit(0);
		break;
	}

	// glutPostRedisplay();

}

void keyboard2(int key, int x, int y)
{
	switch (key)  {
		case GLUT_KEY_UP :
			cout << "up key pressed" << endl;
            break;
        case GLUT_KEY_DOWN:
			cout << "down key pressed" << endl;
			break;
        case GLUT_KEY_LEFT:
			cout << "left key pressed" << endl;
            break;
        case GLUT_KEY_RIGHT:
			cout << "right key pressed" << endl;
            break;
	}

	// glutPostRedisplay();

}

void reshape(int w, int h) { // when user moves our window; 

	glViewport(0, 0, w, h); // viewport transofrmation;

	glMatrixMode(GL_PROJECTION); // projection transformation
	glLoadIdentity();

	gluOrtho2D(0.0, w, 0.0, h);

	glMatrixMode(GL_MODELVIEW); // modelling transformation ;; ant glLookAt must be set before that;
	glLoadIdentity();

	win_height = h;
	win_width = w;

}

void display() { // our actual scene;

	glClear(GL_COLOR_BUFFER_BIT); // our color buffer 'll be cleared;

	//drawSpline();
	drawPolygon();

	glFlush();

}

int main(int argc, char *argv[]) { // our main function;

	glutInit(&argc, argv);

    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);

    glutInitWindowSize(ScreenWidth, ScreenHeight);
    glutInitWindowPosition(100, 100);

    glutCreateWindow ("Scan Line Fill");

    initView(); // initialize our 2d view;

    glutDisplayFunc(display); 
	glutReshapeFunc(reshape);

	glutMouseFunc(mouse);

	glutKeyboardFunc(keyboard);
	glutSpecialFunc(keyboard2);

    glutMainLoop(); 

	return 0;

}
